#include "AnalysisService.h"
#include <pmg/pmg_initSync.h>

#include "Sct/IpcObjectException.h"

#include <ipc/core.h>
#include <boost/scoped_ptr.hpp>

using boost::scoped_ptr;

int main(int argc, char** argv) {
    using namespace SctAnalysis;
    setExceptionHandlers(argv[0]);

    IPCCore::init(argc,argv);

    AnalysisArguments args(argc, argv);
    args.print(std::cout);
    AnalysisService& s=AnalysisService::initialize(args);

    try {
        if (!s.publish()) {
	  IpcObjectException e("Failed to publish Analysis Service", __FILE__, __LINE__);
	  e.sendToMrs(MRS_ERROR);
        }
	
	pmg_initSync();
        s.run();
        s.getServer().run();
        s.withdraw();
    } catch (Throwable& e) {
        e.sendToMrs(MRS_FATAL);
	std::terminate();
    }
}
