#ifndef SCANLIBRARYIMPL_H
#define SCANLIBRARYIMPL_H

#include "ipc/ScanLibrary.h"

namespace SctCalibrationController {
using namespace Ipc;

class ScanLibraryImpl : public ScanLibrary {
public:
    static Sct_CalibrationController::ScanLibrary_ptr instance();
    
    virtual Sct_CalibrationController::ScanRequest_ptr thresholdScan(unsigned long nTrigs);
    virtual Sct_CalibrationController::ScanRequest_ptr thresholdScanfC(unsigned long nTrigs, double calCharge);    
    virtual Sct_CalibrationController::ScanRequest_ptr thresholdScanfCOffset(unsigned long nTrigs, double calCharge, double offset);    
    virtual Sct_CalibrationController::ScanRequest_ptr noiseOccupancyScan();
    virtual Sct_CalibrationController::ScanRequest_ptr strobeDelayScan(unsigned long nTrigs);
    virtual Sct_CalibrationController::ScanRequest_ptr nmaskScan(unsigned long nTrigs);    
    virtual Sct_CalibrationController::ScanRequest_ptr tokenScan();
    virtual Sct_CalibrationController::ScanRequest_ptr defaultScan();
    virtual Sct_CalibrationController::ScanRequest_ptr rawScan(unsigned long nTrigs, CORBA::Boolean issueSoftReset);
private:
    Sct_SctApi::SctApiIPC_var api;
    ScanLibraryImpl();
};    
}

#endif //SCANLIBRARYIMPL_H
