#ifndef CHARACTERIZATIONSEQUENCE_H
#define CHARACTERIZATIONSEQUENCE_H

#include "../ipc/SequenceRequest.h"
#include "../ipc/TestRequest.h"
#include "../ipc/CalibrationController.h"
#include "../ipc/TestLibrary.h"
#include "../ipc/CalibrationController.hh"
#include "Sct/OmniMarshalling.h"
#include <iostream>
#include "Sct/BugReport.h"

using namespace std;

namespace SctCalibrationController {
    
using namespace Ipc;

namespace Scripts {
    
class CharacterizationSequence : public SequenceRequestImpl {
public:	
    static Sct_CalibrationController::SequenceRequest_ptr instance() {
	static CharacterizationSequence cs;
	return cs._this();
    }
    
    virtual char * startSequence(Sct_SctApi::SctApiIPC_ptr api) {
      Sct::BugReport("BUG01", "CharacterisationSequence.h","IS IT THIS ONE? startSequence");
      this->api = Sct_SctApi::SctApiIPC::_duplicate(api);
      return ::Sct::copyStringToCorba("CharacterizationSequence");
    }
    
    virtual Sct_CalibrationController::TestRequest_ptr getNextTest(unsigned long index) {
	Sct_CalibrationController::TestLibrary_var tl = CalibrationControllerImpl::instance()->getTestLibrary();
	switch (index) {
	case 0:
	    return tl->getTestRequestByName("NMask");
	case 1:
#warning Only Barrel combinations of bypass included in characterization sequence
	    return tl->getTestRequestByName("FullBypassBarrel");	    
	case 2:
	    return tl->getTestRequestByName("Pipeline");
	case 3:
	    return tl->getTestRequestByName("StrobeDelay");
	case 4:
	    return tl->getTestRequestByName("ThreePointGain");
	case 5:
            return tl->getTestRequestByName("TrimRange");
        case 6:
	    return tl->getTestRequestByName("ResponseCurve");
	case 7:
	    return tl->getTestRequestByName("NoiseOccupancy");
	case 8:
	    return tl->getTestRequestByName("TimeWalk");
	default:
	    return Sct_CalibrationController::TestRequest::_nil();
	}
    }
    
    virtual void endSequence() {
	api = Sct_SctApi::SctApiIPC::_nil();
    }     
    
private:
    Sct_SctApi::SctApiIPC_var api;
    CharacterizationSequence() {}
};
}
}
#endif //CHARACTERIZATIONSEQUENCE_H
