#ifndef NOISEOCCUPANCYSCAN_H
#define NOISEOCCUPANCYSCAN_H

#include <cmath>  // For fabs

#include "../ipc/CalibrationController.hh"
#include "../CalibrationControllerImpl.h"
#include "../ipc/ScanRequest.h"
#include "../SctApiAccessException.h"
#include "../SctApiCall.h"
#include "Sct/LogicErrors.h"

#include <CommonWithDsp/ABCD/ABCDscans.h>

using namespace Sct;
using namespace SctCalibrationController::Ipc;
namespace SctCalibrationController {
namespace Scripts {

  /** Noise occupancy Scan */

class NoiseOccupancyScan  : public ScanRequestImpl {
public:
    static ScanRequestImpl& noiseOccupancyScan() {
      static NoiseOccupancyScan request;
      Sct_SctApi::SctApiIPC_var api = CalibrationControllerImpl::instance()->getApi();
      Sct_SctApi::Scan_var s;
      APIRETCALL(api, s, createScan(), "Failed to create scan")

	request.setScanNice(s);

        APICALL(s, setNTrigs(1000), "Failed to set triggers")
	
        Sct_SctApi::Trigger_var t;
        APIRETCALL(s, t, getTrigger1(), "Failed to get Trigger1")
	
        APICALL(t, singleL1A(), "Failed to set trigger type")

        APICALL(s, configure(ST_TTHR, 20, -80, -5), "Failed to set Scan information")

	// Too slow to do 1e6 triggers (almost 10mins for these on two modules)
/*         APICALL(s, setVariableTrigRange(0, 4, 1000000), "Failed to set trigger count"); */
        APICALL(s, setVariableTrigRange(0, 8, 100000), "Failed to set trigger count");
        APICALL(s, setVariableTrigRange(9, 11, 10000), "Failed to set trigger count");
        APICALL(s, setVariableTrigRange(12, 20, 1000), "Failed to set trigger count");

	return request;
    }
    
private:
    NoiseOccupancyScan(){;}	
};
    
}
}

#endif //THRESHOLDSCAN_H
