#ifndef STROBEDELAYSCAN_H
#define STROBEDELAYSCAN_H

#include "../ipc/CalibrationController.hh"
#include "../CalibrationControllerImpl.h"
#include "../SctApiAccessException.h"
#include "Sct/LogicErrors.h"
#include "Sct/BugReport.h"

#include <CommonWithDsp/ABCD/ABCDscans.h>

using namespace Sct;
//using namespace SctCalibrationController::Ipc;
namespace SctCalibrationController {
namespace Scripts {

  /** Strobe the cal charge injection relative to the trigger */
    
class StrobeDelayScan : public ScanRequestImpl {
public:
    static ScanRequestImpl& strobeDelayScan(unsigned long nTrigs) {
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 1/12");
      static StrobeDelayScan request;
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 2/12");
      Sct_SctApi::SctApiIPC_var api = CalibrationControllerImpl::instance()->getApi();
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 3/12");
      Sct_SctApi::Scan_var s;
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 4/12");
      APIRETCALL(api, s, createScan(), "Failed to create scan")
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 5/12");
	request.setScanNice(s);
	
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 6/12");
       APICALL(s, setNTrigs(nTrigs), "Failed to set triggers")
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 7/12");

        Sct_SctApi::Trigger_var t;
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 8/12");
        APIRETCALL(s, t, getTrigger1(), "Failed to get Trigger1")

  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 9/12");
        APICALL(t, calL1A(0x82), "Failed to set trigger type")
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 10/12");

        APICALL(s, setOption(Sct_SctApi::Scan::loopCalLine, 1), "Failed to set loopCalLine")
  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 11/12");

        APICALL(s, configure(ST_STROBE_DELAY, 0, 63, 1), "Failed to set Scan information")

  Sct::BugReport("BUG01", "StrobeDelayScan.h","strobeDelayScan 12/12");
        return request;
    }
    
private:
    StrobeDelayScan(){;}
};
    
}
}

#endif //STROBEDELAYSCAN_H
