
#ifndef SCT_NAMEORREGEXP_H
#define SCT_NAMEORREGEXP_H

#include "NameOrRegexp.fwd"

#include <string>
#include <ostream>

std::ostream & operator<<(std::ostream & os, const Sct::NameOrRegexp & nor);

namespace Sct {

  class NameOrRegexp {
  public:
    NameOrRegexp(const std::string & nameOrRegexp, const CORBA::Boolean is_regexp) :
      m_nameOrRegexp(nameOrRegexp),
      m_is_regexp(is_regexp) {
    };
    const CORBA::Boolean is_regexp() const {
      return m_is_regexp;
    };
    std::ostream & printMeTo(std::ostream & os) const {
      return os << "NOR["
                << (m_is_regexp ? "Regexp=" : "Name=")
                << "[" << m_nameOrRegexp << "]]";
    };
  private:
    std::string m_nameOrRegexp;
    CORBA::Boolean m_is_regexp;
  };

};

inline std::ostream & operator<<(std::ostream & os, const Sct::NameOrRegexp & nor) {
  return nor.printMeTo(os);
};

#endif
