/************************************************************************************
 *
 * smSendTxtBuff.h
 *
 *   synopsis: Constants which are needed by smSendTxtBuff.c.
 *             Prototype of smSendTxtBuff(), state machine for text buffer reads and
 *            tellTxtBuffSM(), which writes text buffer structure addresses to the
 *            reply buffer during initialization.
 *
 *   related files:
 *     smSendTxtBuff.c: Contains the state machine for text buffer reads.
 *
 *  Damon Fasching, UW Madison (510)486-5230               fasching@wisconsin.cern.ch
 ************************************************************************************/
                  
#ifndef SM_SEND_TXT_BUFF
#define SM_SEND_TXT_BUFF

#include "processor.h"

/* number of text buffers and text buffer indicies */

#define ERR_BUFF     0
#define INFO_BUFF    1
#define DIAG_BUFF    2
#define XFER_BUFF    3

#define N_TXT_BUFFS  4

#endif

