#ifndef SCT_URANDOM_H
#define SCT_URANDOM_H

// Random numbers that are UNLIKELY to be the same every time!

#include <fstream>

namespace Sct {

  class URandom {

  public:

    static char urandchar() {
      static std::ifstream f("/dev/urandom");
      return f.get();
    };
    
    template <class T>
    static T urand() {
      T ans=0;
      for (unsigned int i=0; i<sizeof(T); i++) {
        ans<<=8;
        T k = ((static_cast<T>(urandchar()))&0xFF);
        //    std::cout << "k is " << k << " while ans is "  << ans << std::endl;
        ans|=k;
      };
      //std:: cout << "seed was " << ans << std::endl;
      return ans; 
    };

  };

};

#endif
