#include "DcsDataStreamer_v1.h"
#include "../DcsData.h"
#include "Sct/IOManager.h"
#include "Sct/IStream.h"
#include "Sct/OStream.h"
#include "boost/shared_ptr.hpp"

using namespace Sct;

namespace SctData {
namespace IO {

unsigned DcsDataStreamer_v1::s_version=1;
/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */

DcsDataStreamer_v1::DcsDataStreamer_v1() throw() {}
	
bool DcsDataStreamer_v1::inMap = IOManager::addToMap("SctData::DcsData",  std::auto_ptr<Streamer>(new DcsDataStreamer_v1()));


shared_ptr<Streamable> DcsDataStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
  boost::shared_ptr<Streamable> m (new DcsData());
  read(in, *m, manager);
  return m;
}

void DcsDataStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    const DcsData& data = dynamic_cast<const DcsData&>(ob);

    std::list<std::string> names = data.getAllParameterNames();

    out << names.size();
    for (std::list<std::string>::const_iterator i=names.begin(); i!=names.end(); ++i){
      out << (*i) << data.getParameter(*i);
    }
}

void DcsDataStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    DcsData& data = dynamic_cast<DcsData&>(ob);

    unsigned n;
    in >> n;
    string name; float val;
    for (unsigned i=0; i<n; ++i){
      in >> name >> val;
      data.setParameter(name, val, long(0));
    }
}

}
}
