#include "TxCurrentTestResultStreamer_v1.h"

using namespace Sct;

namespace SctData {
    namespace IO {

/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
unsigned TxCurrentTestResultStreamer_v1::s_version=1;

	TxCurrentTestResultStreamer_v1::TxCurrentTestResultStreamer_v1() throw() {}
	
bool TxCurrentTestResultStreamer_v1::inMap = IOManager::addToMap("SctData::TxCurrentTestResult",  auto_ptr<Streamer>(new TxCurrentTestResultStreamer_v1()));
	
	shared_ptr<Streamable> TxCurrentTestResultStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
	    boost::shared_ptr<Streamable> ad (new TxCurrentTestResult());
	    read(in, *ad, manager);
	    return ad;
	}
	
	void TxCurrentTestResultStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    //Let superclass do its work
	    manager.writeImpl(out, ob, "SctData::TestResult");
	    
	    //cout << "TxCurrentTestResultStreamer_v1 doing dynamic_cast" << endl;
	    const TxCurrentTestResult& mytest = dynamic_cast<const TxCurrentTestResult&>(ob);
	    
	    for (unsigned int iStream=0; iStream<nLinkModule; iStream++) {
		writeStreamResult(out, mytest.getStreamResult(iStream), manager);
	    }
	}
	
	void TxCurrentTestResultStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    manager.readImpl(in, ob, "SctData::TestResult");
	    
	    TxCurrentTestResult& mytest = dynamic_cast<TxCurrentTestResult&>(ob);
	    
	    for (unsigned int iStream=0; iStream<nLinkModule; iStream++) {
		readStreamResult(in, mytest.getStreamResult(iStream), manager);
	    }
	}
	
	void TxCurrentTestResultStreamer_v1::writeStreamResult(OStream& out, const TxCurrentTestResult::StreamResult& c, const IOManager& manager) const throw (LogicError, IoError) {
          out << c.minErrorFreeTxCurrent() 
              << c.maxErrorFreeTxCurrent()
              << c.bestTxCurrent();
	}
	
	void TxCurrentTestResultStreamer_v1::readStreamResult(IStream& in, TxCurrentTestResult::StreamResult& c, const IOManager& manager) const throw(LogicError, IoError) {
          typedef TxCurrentTestResult::StreamResult::ThresholdType ThresholdType;
          ThresholdType minTmp,maxTmp,bestTmp;
          in >> minTmp >> maxTmp >> bestTmp;
          c.setMinErrorFreeTxCurrent(minTmp);
          c.setMaxErrorFreeTxCurrent(maxTmp);
          c.setBestTxCurrent(bestTmp);
	}
	
    } 
}
