{
  char *env = getenv("DAQ_SW_DIR");
  char *newEnv = getenv("DF_INST_PATH");
  if((env && strlen(env) > 4) || newEnv && strlen(newEnv) > 4)) {
    printf("******* Loading from libTApi.so **********\n");
    gSystem.Load("libTApi.so");
  } else {
    printf("******* Loading from libDTApi.so (Dummy) **********\n");
    gSystem.Load("libDTApi.so");
  }
  TApi *hidden_tapip = new TApi();
  TApi& tapi = *hidden_tapip;

  // Some miscellaneous messages
  tapi.setDebugOption("diag");
  tapi.setDebugOption("diag2");
  // Save all the primitives that are sent
  tapi.setDebugOption("save_prim");
  // Do some standard dumps at some places
//   tapi.setDebugOption("extra_dumps");
  // Essential... save histograms to file, otherwise they'll disappear
  tapi.setDebugOption("save_histogram");
  // Print the decoded version of a probe
  tapi.setDebugOption("verbose_probe");
  // Decode primitives sent to the ROD, and print to stdout
//   tapi.setDebugOption("print_in_prim");
  // Decode primitives from the ROD and print to stdout
//   tapi.setDebugOption("print_out_prim");
  // Include some raw data in the primitive dumps
//   tapi.setDebugOption("print_raw");
  tapi.initialiseAll(1);
//   unsigned int length;
//   unsigned int *body;
//   unsigned int scratch[10000];
//   gROOT.ProcessLine(".L Functs.cxx");
}
