package webconfig;
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(getConfiguration by_number $rootDirectory $lookupDir $bkpDir $cgi_base $plot_DIR $plot_http $instituteName %config %replacedModules %addedModules);
# @EXPORT_OK = qw($rootDataDir $lookupDir $institute);

$VERSION = 1.00;

#use strict;
use Fcntl;

$institute="Unknown";
$rootDataDir="/home";
$lookupDir = "/home";
$bkpDir="/home";
$cgi_base = "http://www-pnp.physics.ox.ac.uk/~daquser/cgi-bin/";
$plot_DIR = "/userdisk/daquser/public_html/dataplots";
$plot_http = "http://www-pnp.physics.ox.ac.uk/~daquser/dataplots/";
%config=();
%replacedModules=();
%addedModules=();


sub getConfiguration {

my $configfile = "/userdisk/daquser/WebLookupData/webscripts.cnf";
if(!(-e "$configfile")) {printError("Configuration file does not exist!");}

open(IN,$configfile) || printError ("Cant open $configfile: $!");
flock(IN,1) || printError("Cant get LOCK_SH on $configfile: $!");

while(<IN>) {
 if(/INSTITUTE=(.*)/) {$instituteName=$1;}
 if(/DATA_ROOT_DIR=(.*)/) {$rootDirectory=$1;}
 if(/WEBLOOKUP_DIR=(.*)/) {$lookupDir=$1;}
 if(/^BKP_DIR=(.*)/) {$bkpDir=$1;}
 if(/^CGI_BASE=(.*)/) {$cgi_base=$1;}
 if(/^PLOT_HTTP=(.*)/) {$plot_http=$1;}
 if(/^PLOT_DIR=(.*)/) {$plot_DIR=$1;}
# REPLACEDMODULE:TYPE=0;LAST=20220040200245;NEXT=20220040200301;FROMRUN=2277
 if(/^REPLACEDMODULE:TYPE=(\d+);LAST=(\d{14});NEXT=(\d{14});FROMRUN=(\d+)/) {
    $replacedModules{$3}{TYPE}=$1;
    $replacedModules{$3}{LAST}=$2;
    $replacedModules{$3}{FROMRUN}=$4;
    }
#ADDMODULE=20220380200139;TYPE=0;LOCATION=Barrel 3, Row 27, Position 6
  if(/^ADDMODULE=(\d{14});TYPE=(\d+);LOCATION=(.*)/) {
    $addedModules{$2}{$1}=$3;
    }

 if(/INDEX=(\d+);(.*)/) {
    my $index=$1;
    my @datas=split(/;/,$2);
    foreach (@datas) {
      if(/(.*)=(.*)/) {$config{$index}{$1}=$2;}
      }
    }
   }
close(IN) || printError("Cant close $configfile: $!");
}

sub by_number {
  ($a <=> $b || $a cmp $b);
  }


sub printError {
 my $emsg=shift;
 print "$emsg";
 die;
 }

1;
